unit Dmtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, RLVirds;

type
  TDmtst = class(TDataModule)
    Master: TEventDataset;
    detail: TEventDataset;
    DataSource1: TDataSource;
    MasterCHFLOAT: TFloatField;
    MasterCHBOOL: TBooleanField;
    MasterCHINT: TIntegerField;
    MasterCHSMALLINT: TSmallintField;
    MasterCHDATE: TDateField;
    MasterCHTIME: TTimeField;
    MasterCHDATETIME: TDateTimeField;
    MasterCHBCD: TBCDField;
    MasterCHSTR: TStringField;
    MasterCHCALC: TStringField;
    procedure MasterLoad(DataSet: TVirtualDataSet; action: TVdsLoadAction);
    procedure MasterUpdaterec(DataSet: TVirtualDataSet;
      action: TUpdateStatus);
    procedure MasterUpdate(DataSet: TVirtualDataSet);
    function getfieldvaluestr(ds : TVirtualDataset) : string;
    function getfieldOldvaluestr(ds : TVirtualDataset) : string;
    function GetStrStatus (stat : TupdateStatus) : string;
    procedure MasterBeforeOpen(DataSet: TDataSet);
    procedure detailLoad(DataSet: TvirtualDataset; action: TVdsLoadAction);
    procedure MasterFilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure MasterBeforePost(DataSet: TDataSet);
    procedure MasterCalcFields(DataSet: TDataSet);
  private
    { Dclarations prives }
    FilterField : string;
    FilterValue : variant;
    Filtertest : string;
  public
    { Dclarations publiques }
    procedure ShowDet;
    procedure SetFilter;
  end;

var
  Dmtst: TDmtst;

implementation

uses Fdebug, Fdet, Ffilter ;

{$R *.DFM}

procedure TDmtst.MasterLoad(DataSet: TVirtualDataSet; action: TVdsLoadAction);
var
  i : integer;
begin
     writedebug('---------------------');
     writedebug('load master called');
     writeDebug(dataset.ParamsDesc.text);
     for i := 0 to dataset.params.count - 1 do
     begin
        Writedebug('param' + inttostr(i) + ' name : ' + Dataset.Params[I].name +
                    ' value : ' + Dataset.Params[I].asstring );
     end
end;

procedure TDmtst.MasterUpdaterec(DataSet: TVirtualDataSet;
  action: TUpdateStatus);
begin
     writedebug('------------------------------------------');
     writedebug('UpdateRec master called');
     writedebug(GetStrStatus(action));
     writedebug(getfieldvaluestr(dataset));
end;

procedure TDmtst.MasterUpdate(DataSet: TVirtualDataSet);
var
   tmpDs : TVirtualDataset;
   SavBuf : TvdsBrowseBuffer;
begin
     writedebug('------------------------------------------');
     writedebug('Update master called');
     TmpDs := Dataset as TVirtualDataset;
     TmPDs.DisableControls;
     SavBuf := Tmpds.BrowseBuffer;
     try
       Tmpds.BrowseBuffer := brModified;
       writedebug('numbers of modified : ' + inttostr(tmpds.recordcount) );
       Tmpds.first;
       while not TmpDs.EOF do
       begin
         writedebug(getfieldvaluestr(tmpds));
         Writedebug('old values :');
         writedebug(getfieldOldvaluestr(tmpds));
         TmpDS.next;
       end;
       Tmpds.BrowseBuffer := brinserted;
       writedebug('numbers of inserted : ' + inttostr(tmpds.recordcount) );
       Tmpds.first;
       while not TmpDs.EOF do
       begin
         writedebug(getfieldvaluestr(tmpds));
         TmpDS.next;
       end;
       Tmpds.BrowseBuffer := brdeleted;
       writedebug('numbers of deleted ' + inttostr(tmpds.recordcount) );
       Tmpds.first;
       while not TmpDs.EOF do
       begin
         writedebug(getfieldvaluestr(tmpds));
         TmpDS.next;
       end;
     finally
       Tmpds.BrowseBuffer := savBuf;
       TmpDs.EnableControls;
     end;


end;

function TDmtst.getfieldvaluestr(ds : TVirtualDataset) : string;
var
   TmpField : Tstringlist;
   i : integer;
begin
    Result := '';
    Tmpfield := Tstringlist.create;
    try
    ds.GetFieldNames(Tmpfield);
    for i := 0 to tmpfield.count -1 do
    begin
      result := result  + tmpfield.strings[I] + ' := '
                + ds.fieldbyname(tmpfield.strings[I]).asstring +  #13#10;
    end;
    finally
      Tmpfield.free;
    end;
end;

function TDmtst.getfieldOldvaluestr(ds : TVirtualDataset) : string;
var
   TmpField : Tstringlist;
   i : integer;
begin
    Result := '';
    Tmpfield := Tstringlist.create;
    try
    ds.GetFieldNames(Tmpfield);
    for i := 0 to tmpfield.count -1 do
    begin
      result := result  + tmpfield.strings[I] + ' := '
                + varTostr(ds.fieldbyname(tmpfield.strings[I]).oldvalue) +  #13#10;
    end;
    finally
      Tmpfield.free;
    end;
end;

function Tdmtst.GetStrStatus (stat : TupdateStatus) : string;
begin
     case stat of
          usUnmodified : result := 'not modified';
          usModified  :  result := 'modified';
          usInserted  : result := 'inserted';
          usDeleted   : result := 'deleted';
     else
         result := 'unknonw';
     end;

end;

procedure TDmtst.MasterBeforeOpen(DataSet: TDataSet);
var
  i : integer;
  TmpDs : TVirtualDataset;
begin
     writedebug('------------------------------------------');
     writedebug('before open master called');

     TmpDs := Dataset as TvirtualDataset;
     writeDebug(TmpDS.ParamsDesc.text);
     for i := 0 to TmpDS.params.count - 1 do
     begin
        Writedebug('param' + inttostr(i) + ' name : ' + TmpDS.Params[I].name +
                    ' value : ' + TmpDS.Params[I].asstring );
     end
end;

procedure TDmtst.detailLoad(DataSet: TvirtualDataset;
  action: TVdsLoadAction);
var
  i : integer;
  TmpDs : TVirtualDataset;
begin
     writedebug('------------------------------------------');
     writedebug('on load detail called');

     TmpDs := Dataset;
     writeDebug(TmpDS.ParamsDesc.text);

     for i := 0 to TmpDS.params.count - 1 do
     begin
        Writedebug('param' + inttostr(i) + ' name : ' + TmpDS.Params[I].name +
                    ' value : ' + TmpDS.Params[I].asstring );
     end;

     // write code to load the detail value depending on the parameter
     // values
   for I := 1 to 10 do
   begin
     TmpDS.InsertRaw;
     Tmpds.FieldByName('CHSTR').value := 'detail rec' + intToStr(i) + ' of ' + TmpDS.Params[0].asstring;
     Tmpds.FieldByName('CHINT').value := i;
     Tmpds.FieldByName('CHFLOAT').value := 3.2 + i;
     TmpDs.PostRaw;
   end;


end;

procedure TdmTst.ShowDet;
begin
   detail.Prepare;
   detail.Open;
   FrmDet.ShowModal;
   detail.Close;
   Detail.UnPrepare;
end;

procedure TdmTst.Setfilter;
begin
  FrmFilter := TfrmFilter.create(self);
  try
    FrmFilter.edFieldname.Text := FilterField;
    FrmFilter.edFieldValue.text := FilterValue;
    Frmfilter.cbFilterTest.itemindex := Frmfilter.cbFilterTest.items.indexof(FilterTest);
    if FrmFilter.ShowModal = mrOk then
    begin
      FilterField := FrmFilter.edFieldname.Text ;
      FilterValue := FrmFilter.edFieldValue.text;
      FilterTest := Frmfilter.cbFilterTest.items[Frmfilter.cbFilterTest.itemindex];

    end;
  finally
    Frmfilter.free;
  end;

end;

procedure TDmtst.MasterFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
  if Filtertest = '=' then
     if dataset.FieldByName(FilterField).value <> FilterValue then Accept := false;
  if Filtertest = '>' then
     if dataset.FieldByName(FilterField).value <= FilterValue then Accept := false;
  if Filtertest = '<' then
     if dataset.FieldByName(FilterField).value >= FilterValue then Accept := false;
end;

procedure TDmtst.MasterBeforePost(DataSet: TDataSet);
begin
  Writedebug('before post called' );
end;

procedure TDmtst.MasterCalcFields(DataSet: TDataSet);
begin
   dataset.fieldByname('CHCALC').value := 'test';
end;

end.
